#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void memory(void) {
	FILE *fd;
	char *fname = "/proc/meminfo";
	char buf[100];
	char *mem1, *mem2, *mem11, *mem12, *mem21, *mem22;
	char *swap1, *swap2, *swap11, *swap12=NULL, *swap21, *swap22;
	int mem13, mem23, swap13, swap23;

	fd = fopen(fname, "r");
	if ( !fd ) {
		fprintf(stderr, "Could not open %s. Bailing out.\n", fname);
		return;
	}

	puts("");
	printf("  Memory\n\n");
	printf("  RAM:\n");

	while ( fgets(buf, sizeof buf, fd) ) {
		mem1 = strstr(buf,"MemTotal");
		mem2 = strstr(buf,"MemFree");
		swap1 = strstr(buf,"SwapTotal");
		swap2 = strstr(buf,"SwapFree");

		if ( mem1 ) {
			mem11 = strchr(mem1, 'k');
			if ( mem11 ) {
				mem11[-1] = 0;
				mem12 = strchr(mem1,':')+1;
				mem13 = (atoi(mem12) / 1024);
				printf("  Total:\t%i MB\n", mem13);
			}
		}
		if ( mem2 ) {
			mem21 = strchr(mem2, 'k');
			if ( mem21 ) {
				mem21[-1] = 0;
				mem22 = strchr(mem2,':')+1;
				mem23 = (atoi(mem22) / 1024);
				printf("  Free:\t\t%i MB\n", mem23);
			}
		}
		if ( swap1 ) {
			printf("\n  Swap:\n");
			swap11 = strchr(swap1, 'k');
			if ( swap11 ) {
				swap11[-1] = 0;
				swap12 = strchr(swap1,':')+1;
				swap13 = (atoi(swap12) / 1000);
				printf("  Total:\t%i MB\n", swap13);
			}

		}
		if ( swap2 ) {
			swap21 = strchr(swap2, 'k');
			if ( swap21 ) {
				swap21[-1] = 0;
				swap22 = strchr(swap2,':')+1;
				swap23 = (atoi(swap12) / 1000);
				printf("  Free:\t\t%i MB\n", swap23);
			}
		}
	}

	puts("");
	fclose(fd);
}

