#include <stdio.h>
#include <string.h>

void partitions(void) {
	FILE *fd;
	char *fname = "/etc/mtab";
	char buf[100];
	char *p1, *p2, *p3, *p4;

	fd = fopen(fname, "r");
	if ( !fd ) {
		fprintf(stderr, "Could not open %s. Bailing out.\n", fname);
		return;
	}

	puts("");
	printf("  Partitions\n\n");

	while ( fgets(buf, sizeof buf, fd ) ) {
		p1 = strstr(buf,"/dev/hda");
		p2 = strstr(buf,"/dev/hdb");
		p3 = strstr(buf,"/dev/hdc");
		p4 = strstr(buf,"/dev/hdd");

		if ( p1 ) {
			printf("  %s", p1);
		}
		if ( p2 ) {
			printf("  %s", p2);
		}
		if ( p3 ) {
			printf("  %s", p3);
		}
		if ( p4 ) {
			printf("  %s", p4);
		}
	}

	puts("");
	fclose(fd);
}
