#include <stdio.h>
#include <string.h>

void cpuinfo(void) {
	FILE *fd;
	char *fname = "/proc/cpuinfo";
	char buf[100];
	char *cpu1, *cpu2, *cpu3, *cpu4, *cpu5;

	fd = fopen(fname, "r");
	if ( !fd ) {
		fprintf(stderr, "Could not to open %s. Bailing out.\n", fname);
		return;
	}
	
	puts("");
	printf("  Processor\n\n");

	while ( fgets(buf, sizeof buf, fd) ) {
	        cpu1=strstr(buf,"vendor_id"); 
		cpu2=strstr(buf,"model name");
		cpu3=strstr(buf,"cpu MHz");
		cpu4=strstr(buf,"bogomips");
		cpu5=strstr(buf,"cache size");

		if ( cpu1 ) {
			printf("  Type:\t\t%s", strchr(cpu1,':')+1 );
		}
	        if ( cpu2 ) {
			printf("  Model:\t%s", strchr(cpu2,':')+1 );
		}
	        if ( cpu3 ) {
			printf("  Frequency:\t%s", strchr(cpu3,':')+1 );
		}
	        if ( cpu4 ) {
			printf("  Bogomips:\t%s", strchr(cpu4,':')+1 );
		}
	        if ( cpu5 ) {
			printf("  Cache:\t%s", strchr(cpu5,':')+1 );
		}
	}

	puts("");
	fclose(fd);
}
