#include <stdio.h>
#include <string.h>

void sound(void) {
	FILE *fd;
	char *fname = "/proc/pci";
	char buf[100];
	char *card, *card2, *card3;
	int found = 0;

	fd = fopen(fname, "r");
	if ( !fd ) {
		fprintf(stderr, "Could not open %s. Bailing out.\n", fname);
		return;
	}

	puts("");
	printf("  Sound\n\n");
	printf("  Soundcard:\n");

	while ( fgets(buf, sizeof buf, fd) ) {
	        card = strstr(buf,"audio");
		if ( card ) {
			card2 = strchr(card, '(');
			if ( card2 ) {
				found = 1;
				card2[-1] = 0;
				card3 = strchr(card,':')+1;
				printf(" %s\n", card3);
			}
		}
	}

	if ( !found ) {
		printf("  Could not find any soundcard.\n");
	}

	puts("");
	fclose(fd);
}
